Index: gnu/usr.bin/perl/AUTHORS
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/AUTHORS,v
retrieving revision 1.10
diff -u -p -a -u -p -r1.10 AUTHORS
--- gnu/usr.bin/perl/AUTHORS	15 Feb 2023 01:36:12 -0000	1.10
+++ gnu/usr.bin/perl/AUTHORS	21 May 2023 00:39:33 -0000
@@ -434,6 +434,7 @@ Edward Moy                     <emoy@app
 Edward Peschko                 <edwardp@excitehome.net>
 Elaine -HFB- Ashton            <elaine@chaos.wustl.edu>
 Elizabeth Mattijsen            <liz@dijkmat.nl>
+Elvin Aslanov                  <rwp.primary@gmail.com>
 Enrico Sorcinelli              <bepi@perl.it>
 Eric Amick
 Eric Arnold                    <eric.arnold@sun.com>
Index: gnu/usr.bin/perl/INSTALL
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/INSTALL,v
retrieving revision 1.28
diff -u -p -a -u -p -r1.28 INSTALL
--- gnu/usr.bin/perl/INSTALL	15 Feb 2023 01:36:12 -0000	1.28
+++ gnu/usr.bin/perl/INSTALL	21 May 2023 00:39:33 -0000
@@ -90,10 +90,10 @@ to F<pod/perldelta.pod> for more detaile
 
 =head3 Compatibility with earlier versions
 
-B<WARNING:> This version is not binary compatible with earlier versions
-of Perl.  If you have built extensions (i.e. modules that include C code)
-using an earlier version of Perl, you will need to rebuild and reinstall
-those extensions.
+B<WARNING:> This version is not binary compatible with versions of Perl
+earlier than 5.36.0.  If you have built extensions (i.e. modules that
+include C code) using an earlier version of Perl, you will need to
+rebuild and reinstall those extensions.
 
 Pure perl modules without XS or C code should continue to work fine
 without reinstallation.  See the discussion below on
@@ -683,7 +683,7 @@ The directories set up by Configure fall
 
 =item Directories for the perl distribution
 
-By default, Configure will use the following directories for 5.36.0.
+By default, Configure will use the following directories for 5.36.1.
 $version is the full perl version number, including subversion, e.g.
 5.12.3, and $archname is a string like sun4-sunos,
 determined by Configure.  The full definitions of all Configure
@@ -2506,8 +2506,8 @@ L<https://www.chiark.greenend.org.uk/~sg
 
 =head1 Coexistence with earlier versions of perl 5
 
-Perl 5.36.0 is not binary compatible with earlier versions of Perl.
-In other words, you will have to recompile your XS modules.
+Perl 5.36.1 is not binary compatible with versions of Perl earlier than.
+5.36.0.  In other words, you will have to recompile your XS modules.
 
 In general, you can usually safely upgrade from one stable version of Perl
 (e.g. 5.30.0) to another similar minor version (e.g. 5.30.1) without
@@ -2581,9 +2581,9 @@ won't interfere with another version.  (
 libraries after 5.6.0, but not for executables. TODO?)  One convenient
 way to do this is by using a separate prefix for each version, such as
 
-	sh Configure -Dprefix=/opt/perl5.36.0
+	sh Configure -Dprefix=/opt/perl5.36.1
 
-and adding /opt/perl5.36.0/bin to the shell PATH variable.  Such users
+and adding /opt/perl5.36.1/bin to the shell PATH variable.  Such users
 may also wish to add a symbolic link /usr/local/bin/perl so that
 scripts can still start with #!/usr/local/bin/perl.
 
@@ -2598,11 +2598,11 @@ yet.
 
 =head2 Upgrading from 5.35.11 or earlier
 
-B<Perl 5.36.0 may not be binary compatible with Perl 5.35.11 or
+B<Perl 5.36.1 may not be binary compatible with Perl 5.35.11 or
 earlier Perl releases.>  Perl modules having binary parts
 (meaning that a C compiler is used) will have to be recompiled to be
-used with 5.36.0.  If you find you do need to rebuild an extension with
-5.36.0, you may safely do so without disturbing the older
+used with 5.36.1.  If you find you do need to rebuild an extension with
+5.36.1, you may safely do so without disturbing the older
 installations.  (See L<"Coexistence with earlier versions of perl 5">
 above.)
 
@@ -2635,15 +2635,15 @@ Firstly, the bare minimum to run this sc
      print("$f\n");
   }
 
-in Linux with perl-5.36.0 is as follows (under $Config{prefix}):
+in Linux with perl-5.36.1 is as follows (under $Config{prefix}):
 
   ./bin/perl
-  ./lib/perl5/5.36.0/strict.pm
-  ./lib/perl5/5.36.0/warnings.pm
-  ./lib/perl5/5.36.0/i686-linux/File/Glob.pm
-  ./lib/perl5/5.36.0/feature.pm
-  ./lib/perl5/5.36.0/XSLoader.pm
-  ./lib/perl5/5.36.0/i686-linux/auto/File/Glob/Glob.so
+  ./lib/perl5/5.36.1/strict.pm
+  ./lib/perl5/5.36.1/warnings.pm
+  ./lib/perl5/5.36.1/i686-linux/File/Glob.pm
+  ./lib/perl5/5.36.1/feature.pm
+  ./lib/perl5/5.36.1/XSLoader.pm
+  ./lib/perl5/5.36.1/i686-linux/auto/File/Glob/Glob.so
 
 Secondly, for perl-5.10.1, the Debian perl-base package contains 591
 files, (of which 510 are for lib/unicore) totaling about 3.5MB in its
Index: gnu/usr.bin/perl/MANIFEST
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/MANIFEST,v
retrieving revision 1.66
diff -u -p -a -u -p -r1.66 MANIFEST
--- gnu/usr.bin/perl/MANIFEST	15 Feb 2023 01:39:49 -0000	1.66
+++ gnu/usr.bin/perl/MANIFEST	21 May 2023 00:39:33 -0000
@@ -5875,6 +5875,7 @@ pod/perl5320delta.pod		Perl changes in v
 pod/perl5321delta.pod		Perl changes in version 5.32.1
 pod/perl5340delta.pod		Perl changes in version 5.34.0
 pod/perl5341delta.pod		Perl changes in version 5.34.1
+pod/perl5360delta.pod		Perl changes in version 5.36.0
 pod/perl561delta.pod		Perl changes in version 5.6.1
 pod/perl56delta.pod		Perl changes in version 5.6
 pod/perl581delta.pod		Perl changes in version 5.8.1
Index: gnu/usr.bin/perl/Makefile.SH
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/Makefile.SH,v
retrieving revision 1.59
diff -u -p -a -u -p -r1.59 Makefile.SH
--- gnu/usr.bin/perl/Makefile.SH	15 Feb 2023 01:39:49 -0000	1.59
+++ gnu/usr.bin/perl/Makefile.SH	21 May 2023 00:39:33 -0000
@@ -614,7 +614,7 @@ esac
 
 $spitshell >>$Makefile <<'!NO!SUBS!'
 
-perltoc_pod_prereqs = extra.pods pod/perl5360delta.pod pod/perlapi.pod pod/perlintern.pod pod/perlmodlib.pod
+perltoc_pod_prereqs = extra.pods pod/perl5361delta.pod pod/perlapi.pod pod/perlintern.pod pod/perlmodlib.pod
 generated_pods = pod/perltoc.pod $(perltoc_pod_prereqs)
 generated_headers = uudmap.h bitcount.h mg_data.h
 
@@ -1129,9 +1129,9 @@ pod/perlintern.pod: $(MINIPERL_EXE) auto
 pod/perlmodlib.pod: $(MINIPERL_EXE) pod/perlmodlib.PL MANIFEST
 	$(MINIPERL) pod/perlmodlib.PL -q
 
-pod/perl5360delta.pod: pod/perldelta.pod
-	$(RMS) pod/perl5360delta.pod
-	$(LNS) perldelta.pod pod/perl5360delta.pod
+pod/perl5361delta.pod: pod/perldelta.pod
+	$(RMS) pod/perl5361delta.pod
+	$(LNS) perldelta.pod pod/perl5361delta.pod
 
 extra.pods: $(MINIPERL_EXE)
 	-@test ! -f extra.pods || rm -f `cat extra.pods`
Index: gnu/usr.bin/perl/README
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/README,v
retrieving revision 1.22
diff -u -p -a -u -p -r1.22 README
--- gnu/usr.bin/perl/README	15 Feb 2023 01:36:12 -0000	1.22
+++ gnu/usr.bin/perl/README	21 May 2023 00:39:33 -0000
@@ -1,7 +1,5 @@
-Perl is Copyright (C) 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000,
-2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012,
-2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021, 2022
-by Larry Wall and others.
+Perl is Copyright (C) 1993 - 2023 by Larry Wall and others.
+
 All rights reserved.
 
 
Index: gnu/usr.bin/perl/README.haiku
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/README.haiku,v
retrieving revision 1.12
diff -u -p -a -u -p -r1.12 README.haiku
--- gnu/usr.bin/perl/README.haiku	15 Feb 2023 01:36:12 -0000	1.12
+++ gnu/usr.bin/perl/README.haiku	21 May 2023 00:39:33 -0000
@@ -22,9 +22,9 @@ The build procedure is completely standa
 Make perl executable and create a symlink for libperl:
 
   chmod a+x /boot/common/bin/perl
-  cd /boot/common/lib; ln -s perl5/5.36.0/BePC-haiku/CORE/libperl.so .
+  cd /boot/common/lib; ln -s perl5/5.36.1/BePC-haiku/CORE/libperl.so .
 
-Replace C<5.36.0> with your respective version of Perl.
+Replace C<5.36.1> with your respective version of Perl.
 
 =head1 KNOWN PROBLEMS
 
Index: gnu/usr.bin/perl/README.macosx
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/README.macosx,v
retrieving revision 1.12
diff -u -p -a -u -p -r1.12 README.macosx
--- gnu/usr.bin/perl/README.macosx	15 Feb 2023 01:36:12 -0000	1.12
+++ gnu/usr.bin/perl/README.macosx	21 May 2023 00:39:33 -0000
@@ -10,9 +10,9 @@ perlmacosx - Perl under Mac OS X
 
 This document briefly describes Perl under Mac OS X.
 
-  curl -O https://www.cpan.org/src/perl-5.36.0.tar.gz
-  tar -xzf perl-5.36.0.tar.gz
-  cd perl-5.36.0
+  curl -O https://www.cpan.org/src/perl-5.36.1.tar.gz
+  tar -xzf perl-5.36.1.tar.gz
+  cd perl-5.36.1
   ./Configure -des -Dprefix=/usr/local/
   make
   make test
@@ -20,7 +20,7 @@ This document briefly describes Perl und
 
 =head1 DESCRIPTION
 
-The latest Perl release (5.36.0 as of this writing) builds without changes
+The latest Perl release (5.36.1 as of this writing) builds without changes
 under all versions of Mac OS X from 10.3 "Panther" onwards. 
 
 In order to build your own version of Perl you will need 'make',
Index: gnu/usr.bin/perl/README.os2
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/README.os2,v
retrieving revision 1.28
diff -u -p -a -u -p -r1.28 README.os2
--- gnu/usr.bin/perl/README.os2	15 Feb 2023 01:36:12 -0000	1.28
+++ gnu/usr.bin/perl/README.os2	21 May 2023 00:39:33 -0000
@@ -619,7 +619,7 @@ C<set PERLLIB_PREFIX> in F<Config.sys>, 
 
 =item Additional Perl modules
 
-  unzip perl_ste.zip -d f:/perllib/lib/site_perl/5.36.0/
+  unzip perl_ste.zip -d f:/perllib/lib/site_perl/5.36.1/
 
 Same remark as above applies.  Additionally, if this directory is not
 one of directories on @INC (and @INC is influenced by C<PERLLIB_PREFIX>), you
Index: gnu/usr.bin/perl/README.vms
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/README.vms,v
retrieving revision 1.29
diff -u -p -a -u -p -r1.29 README.vms
--- gnu/usr.bin/perl/README.vms	15 Feb 2023 01:36:12 -0000	1.29
+++ gnu/usr.bin/perl/README.vms	21 May 2023 00:39:33 -0000
@@ -137,11 +137,11 @@ You may need to set up a foreign symbol 
 choice.  Once you have done so, use a command like the following to
 unpack the archive:
 
-    vmstar -xvf perl-5^.36^.0.tar
+    vmstar -xvf perl-5^.36^.1.tar
 
 Then set default to the top-level source directory like so:
 
-    set default [.perl-5^.36^.0]
+    set default [.perl-5^.36^.1]
 
 and proceed with configuration as described in the next section.
 
Index: gnu/usr.bin/perl/configure.com
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/configure.com,v
retrieving revision 1.10
diff -u -p -a -u -p -r1.10 configure.com
--- gnu/usr.bin/perl/configure.com	15 Feb 2023 01:36:13 -0000	1.10
+++ gnu/usr.bin/perl/configure.com	21 May 2023 00:39:33 -0000
@@ -1160,8 +1160,7 @@ $! base name early because not all quest
 $! platforms.
 $!
 $! Please use F$ELEMENT(0,"-",archname) .EQS. "VMS_AXP" (or
-$! "VMS_IA64") from here on to allow cross-platform configuration (e.g.
-$! configure a IA64 build on an Alpha).
+$! "VMS_IA64", "VMS_x86_64", etc.) from here on to query the current architecture.
 $!
 $ IF (F$GETSYI("HW_MODEL") .LT. 1024 .AND. F$GETSYI("HW_MODEL") .GT. 0)
 $ THEN 
@@ -1171,16 +1170,15 @@ $   exit 44
 $ ELSE
 $   IF (F$GETSYI("ARCH_TYPE") .EQ. 2)
 $   THEN
-$       archname = "VMS_AXP"
-$       otherarch = "IA64"
+$       archname = "VMS_AXP"  ! oops, F$GETSYI("ARCH_NAME") gives us 'Alpha' not 'AXP'
 $       arch_type = "ARCH-TYPE=__AXP__"
 $   ELSE
-$       archname = "VMS_IA64"
-$       otherarch = "Alpha"
-$       arch_type = "ARCH-TYPE=__IA64__"
+$!      This works for Itanium and x86_64 and hopefully whatever's next (AARCH64? RISC-V?)
+$       archname = "VMS_" + F$GETSYI("ARCH_NAME")
+$       arch_type = "ARCH-TYPE=__" + F$GETSYI("ARCH_NAME") + "__"
 $   ENDIF
-$   alignbytes="8"
 $ ENDIF
+$ alignbytes="8"
 $!
 $!: set the base revision
 $ baserev="5.0"
Index: gnu/usr.bin/perl/embed.fnc
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/embed.fnc,v
retrieving revision 1.13
diff -u -p -a -u -p -r1.13 embed.fnc
--- gnu/usr.bin/perl/embed.fnc	15 Feb 2023 01:36:13 -0000	1.13
+++ gnu/usr.bin/perl/embed.fnc	21 May 2023 00:39:35 -0000
@@ -3079,21 +3079,21 @@ i	|HV*	|opmethod_stash	|NN SV* meth
 #endif
 
 #if defined(PERL_IN_PP_SORT_C)
-I	|I32	|sv_ncmp	|NN SV *const a|NN SV *const b
-I	|I32	|sv_ncmp_desc	|NN SV *const a|NN SV *const b
-I	|I32	|sv_i_ncmp	|NN SV *const a|NN SV *const b
-I	|I32	|sv_i_ncmp_desc	|NN SV *const a|NN SV *const b
-I	|I32	|amagic_ncmp	|NN SV *const a|NN SV *const b
-I	|I32	|amagic_ncmp_desc	|NN SV *const a|NN SV *const b
-I	|I32	|amagic_i_ncmp	|NN SV *const a|NN SV *const b
-I	|I32	|amagic_i_ncmp_desc	|NN SV *const a|NN SV *const b
-I	|I32	|amagic_cmp	|NN SV *const str1|NN SV *const str2
-I	|I32	|amagic_cmp_desc	|NN SV *const str1|NN SV *const str2
-I	|I32	|cmp_desc	|NN SV *const str1|NN SV *const str2
+i	|I32	|sv_ncmp	|NN SV *const a|NN SV *const b
+i	|I32	|sv_ncmp_desc	|NN SV *const a|NN SV *const b
+i	|I32	|sv_i_ncmp	|NN SV *const a|NN SV *const b
+i	|I32	|sv_i_ncmp_desc	|NN SV *const a|NN SV *const b
+i	|I32	|amagic_ncmp	|NN SV *const a|NN SV *const b
+i	|I32	|amagic_ncmp_desc	|NN SV *const a|NN SV *const b
+i	|I32	|amagic_i_ncmp	|NN SV *const a|NN SV *const b
+i	|I32	|amagic_i_ncmp_desc	|NN SV *const a|NN SV *const b
+i	|I32	|amagic_cmp	|NN SV *const str1|NN SV *const str2
+i	|I32	|amagic_cmp_desc	|NN SV *const str1|NN SV *const str2
+i	|I32	|cmp_desc	|NN SV *const str1|NN SV *const str2
 #  ifdef USE_LOCALE_COLLATE
-I	|I32	|amagic_cmp_locale     |NN SV *const str1|NN SV *const str2
-I	|I32	|amagic_cmp_locale_desc|NN SV *const str1|NN SV *const str2
-I	|I32	|cmp_locale_desc|NN SV *const str1|NN SV *const str2
+i	|I32	|amagic_cmp_locale     |NN SV *const str1|NN SV *const str2
+i	|I32	|amagic_cmp_locale_desc|NN SV *const str1|NN SV *const str2
+i	|I32	|cmp_locale_desc|NN SV *const str1|NN SV *const str2
 #  endif
 S	|I32	|sortcv		|NN SV *const a|NN SV *const b
 S	|I32	|sortcv_xsub	|NN SV *const a|NN SV *const b
@@ -3346,9 +3346,11 @@ ST	|void	|mem_log_common	|enum mem_log_t
 #endif
 
 #if defined(PERL_MEM_LOG)
-pT	|Malloc_t	|mem_log_alloc	|const UV nconst|UV typesize|NN const char *type_name|Malloc_t newalloc|NN const char *filename|const int linenumber|NN const char *funcname
-pT	|Malloc_t	|mem_log_realloc	|const UV n|const UV typesize|NN const char *type_name|Malloc_t oldalloc|Malloc_t newalloc|NN const char *filename|const int linenumber|NN const char *funcname
-pT	|Malloc_t	|mem_log_free	|Malloc_t oldalloc|NN const char *filename|const int linenumber|NN const char *funcname
+CpT	|Malloc_t	|mem_log_alloc	|const UV nconst|UV typesize|NN const char *type_name|Malloc_t newalloc|NN const char *filename|const int linenumber|NN const char *funcname
+CpT	|Malloc_t	|mem_log_realloc	|const UV n|const UV typesize|NN const char *type_name|Malloc_t oldalloc|Malloc_t newalloc|NN const char *filename|const int linenumber|NN const char *funcname
+CpT	|Malloc_t	|mem_log_free	|Malloc_t oldalloc|NN const char *filename|const int linenumber|NN const char *funcname
+CpT	|void		|mem_log_new_sv|NN const SV *sv|NN const char *filename|int linenumber|NN const char *funcname
+CpT	|void		|mem_log_del_sv|NN const SV *sv|NN const char *filename|int linenumber|NN const char *funcname
 #endif
 
 #if defined(PERL_IN_UTF8_C)
Index: gnu/usr.bin/perl/embed.h
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/embed.h,v
retrieving revision 1.28
diff -u -p -a -u -p -r1.28 embed.h
--- gnu/usr.bin/perl/embed.h	15 Feb 2023 01:36:13 -0000	1.28
+++ gnu/usr.bin/perl/embed.h	21 May 2023 00:39:35 -0000
@@ -887,6 +887,13 @@
 #if defined(PERL_IN_SV_C)
 #define more_sv()		Perl_more_sv(aTHX)
 #endif
+#if defined(PERL_MEM_LOG)
+#define mem_log_alloc		Perl_mem_log_alloc
+#define mem_log_del_sv		Perl_mem_log_del_sv
+#define mem_log_free		Perl_mem_log_free
+#define mem_log_new_sv		Perl_mem_log_new_sv
+#define mem_log_realloc		Perl_mem_log_realloc
+#endif
 #if defined(PERL_USE_3ARG_SIGHANDLER)
 #define csighandler		Perl_csighandler
 #endif
@@ -2028,11 +2035,6 @@
 #    if defined(PERL_MEM_LOG) && !defined(PERL_MEM_LOG_NOIMPL)
 #define mem_log_common		S_mem_log_common
 #    endif
-#  endif
-#  if defined(PERL_MEM_LOG)
-#define mem_log_alloc		Perl_mem_log_alloc
-#define mem_log_free		Perl_mem_log_free
-#define mem_log_realloc		Perl_mem_log_realloc
 #  endif
 #  if defined(PERL_USES_PL_PIDSTATUS) && defined(PERL_IN_UTIL_C)
 #define pidgone(a,b)		S_pidgone(aTHX_ a,b)
Index: gnu/usr.bin/perl/gv.c
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/gv.c,v
retrieving revision 1.23
diff -u -p -a -u -p -r1.23 gv.c
--- gnu/usr.bin/perl/gv.c	15 Feb 2023 01:36:13 -0000	1.23
+++ gnu/usr.bin/perl/gv.c	21 May 2023 00:39:35 -0000
@@ -982,7 +982,7 @@ S_gv_fetchmeth_internal(pTHX_ HV* stash,
         }
     }
 
-    if (topgv && GvREFCNT(topgv) == 1) {
+    if (topgv && GvREFCNT(topgv) == 1 && !(flags & GV_NOUNIVERSAL)) {
         /* cache the fact that the method is not defined */
         GvCVGEN(topgv) = topgen_cmp;
     }
Index: gnu/usr.bin/perl/handy.h
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/handy.h,v
retrieving revision 1.21
diff -u -p -a -u -p -r1.21 handy.h
--- gnu/usr.bin/perl/handy.h	15 Feb 2023 01:36:13 -0000	1.21
+++ gnu/usr.bin/perl/handy.h	21 May 2023 00:39:35 -0000
@@ -2734,10 +2734,6 @@ enum mem_log_type {
   MLT_DEL_SV
 };
 #  endif
-#  if defined(PERL_IN_SV_C)  /* those are only used in sv.c */
-void Perl_mem_log_new_sv(const SV *sv, const char *filename, const int linenumber, const char *funcname);
-void Perl_mem_log_del_sv(const SV *sv, const char *filename, const int linenumber, const char *funcname);
-#  endif
 # endif
 
 #endif
Index: gnu/usr.bin/perl/makedef.pl
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/makedef.pl,v
retrieving revision 1.16
diff -u -p -a -u -p -r1.16 makedef.pl
--- gnu/usr.bin/perl/makedef.pl	15 Feb 2023 01:36:13 -0000	1.16
+++ gnu/usr.bin/perl/makedef.pl	21 May 2023 00:39:36 -0000
@@ -489,7 +489,14 @@ unless ($define{'PERL_TRACK_MEMPOOL'}) {
 }
 
 unless ($define{'PERL_MEM_LOG'}) {
-    ++$skip{PL_mem_log};
+    ++$skip{$_} foreach qw(
+                    PL_mem_log
+                    Perl_mem_log_alloc
+                    Perl_mem_log_realloc
+                    Perl_mem_log_free
+                    Perl_mem_log_new_sv
+                    Perl_mem_log_del_sv
+                );
 }
 
 unless ($define{'MULTIPLICITY'}) {
Index: gnu/usr.bin/perl/mg.c
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/mg.c,v
retrieving revision 1.27
diff -u -p -a -u -p -r1.27 mg.c
--- gnu/usr.bin/perl/mg.c	15 Feb 2023 01:36:13 -0000	1.27
+++ gnu/usr.bin/perl/mg.c	21 May 2023 00:39:36 -0000
@@ -3082,25 +3082,55 @@ Perl_magic_set(pTHX_ SV *sv, MAGIC *mg)
             IoLINES(GvIOp(PL_last_in_gv)) = SvIV(sv);
         break;
     case '^':
-        Safefree(IoTOP_NAME(GvIOp(PL_defoutgv)));
-        IoTOP_NAME(GvIOp(PL_defoutgv)) = savesvpv(sv);
-        IoTOP_GV(GvIOp(PL_defoutgv)) =  gv_fetchsv(sv, GV_ADD, SVt_PVIO);
+        {
+            IO * const io = GvIO(PL_defoutgv);
+            if (!io)
+                break;
+
+            Safefree(IoTOP_NAME(io));
+            IoTOP_NAME(io) = savesvpv(sv);
+            IoTOP_GV(io) =  gv_fetchsv(sv, GV_ADD, SVt_PVIO);
+        }
         break;
     case '~':
-        Safefree(IoFMT_NAME(GvIOp(PL_defoutgv)));
-        IoFMT_NAME(GvIOp(PL_defoutgv)) = savesvpv(sv);
-        IoFMT_GV(GvIOp(PL_defoutgv)) =  gv_fetchsv(sv, GV_ADD, SVt_PVIO);
+        {
+            IO * const io = GvIO(PL_defoutgv);
+            if (!io)
+                break;
+
+            Safefree(IoFMT_NAME(io));
+            IoFMT_NAME(io) = savesvpv(sv);
+            IoFMT_GV(io) =  gv_fetchsv(sv, GV_ADD, SVt_PVIO);
+        }
         break;
     case '=':
-        IoPAGE_LEN(GvIOp(PL_defoutgv)) = (SvIV(sv));
+        {
+            IO * const io = GvIO(PL_defoutgv);
+            if (!io)
+                break;
+
+            IoPAGE_LEN(io) = (SvIV(sv));
+        }
         break;
     case '-':
-        IoLINES_LEFT(GvIOp(PL_defoutgv)) = (SvIV(sv));
-        if (IoLINES_LEFT(GvIOp(PL_defoutgv)) < 0L)
-                IoLINES_LEFT(GvIOp(PL_defoutgv)) = 0L;
+        {
+            IO * const io = GvIO(PL_defoutgv);
+            if (!io)
+                break;
+
+            IoLINES_LEFT(io) = (SvIV(sv));
+            if (IoLINES_LEFT(io) < 0L)
+                IoLINES_LEFT(io) = 0L;
+        }
         break;
     case '%':
-        IoPAGE(GvIOp(PL_defoutgv)) = (SvIV(sv));
+        {
+            IO * const io = GvIO(PL_defoutgv);
+            if (!io)
+                break;
+
+            IoPAGE(io) = (SvIV(sv));
+        }
         break;
     case '|':
         {
Index: gnu/usr.bin/perl/op.c
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/op.c,v
retrieving revision 1.26
diff -u -p -a -u -p -r1.26 op.c
--- gnu/usr.bin/perl/op.c	15 Feb 2023 01:36:13 -0000	1.26
+++ gnu/usr.bin/perl/op.c	21 May 2023 00:39:36 -0000
@@ -14749,13 +14749,40 @@ subroutine.
 CV *
 Perl_find_lexical_cv(pTHX_ PADOFFSET off)
 {
-    PADNAME *name = PAD_COMPNAME(off);
+    const PADNAME *name = PAD_COMPNAME(off);
     CV *compcv = PL_compcv;
     while (PadnameOUTER(name)) {
-        assert(PARENT_PAD_INDEX(name));
         compcv = CvOUTSIDE(compcv);
-        name = PadlistNAMESARRAY(CvPADLIST(compcv))
+        if (LIKELY(PARENT_PAD_INDEX(name))) {
+            name = PadlistNAMESARRAY(CvPADLIST(compcv))
                 [off = PARENT_PAD_INDEX(name)];
+        }
+        else {
+            /* In an eval() in an inner scope like a function, the
+               intermediate pad in the sub might not be populated with the
+               sub.  So search harder.
+
+               It is possible we won't find the name in this
+               particular scope, but that's fine, if we don't we'll
+               find it in some outer scope.  Finding it here will let us
+               go back to following the PARENT_PAD_INDEX() chain.
+            */
+            const PADNAMELIST * const names = PadlistNAMES(CvPADLIST(compcv));
+            PADNAME * const * const name_p = PadnamelistARRAY(names);
+            int offset;
+            for (offset = PadnamelistMAXNAMED(names); offset > 0; offset--) {
+                const PADNAME * const thisname = name_p[offset];
+                /* The pv is copied from the outer PADNAME to the
+                   inner PADNAMEs so we don't need to compare the
+                   string contents
+                */
+                if (thisname && PadnameLEN(thisname) == PadnameLEN(name)
+                    && PadnamePV(thisname) == PadnamePV(name)) {
+                    name = thisname;
+                    break;
+                }
+            }
+        }
     }
     assert(!PadnameIsOUR(name));
     if (!PadnameIsSTATE(name) && PadnamePROTOCV(name)) {
Index: gnu/usr.bin/perl/patchlevel.h
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/patchlevel.h,v
retrieving revision 1.52
diff -u -p -a -u -p -r1.52 patchlevel.h
--- gnu/usr.bin/perl/patchlevel.h	15 Feb 2023 01:36:13 -0000	1.52
+++ gnu/usr.bin/perl/patchlevel.h	21 May 2023 00:39:36 -0000
@@ -39,7 +39,7 @@ Instead use one of the version compariso
 
 #define PERL_REVISION	5		/* age */
 #define PERL_VERSION	36		/* epoch */
-#define PERL_SUBVERSION	0		/* generation */
+#define PERL_SUBVERSION	1		/* generation */
 
 /* The following numbers describe the earliest compatible version of
    Perl ("compatibility" here being defined as sufficient binary/API
Index: gnu/usr.bin/perl/perl.c
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/perl.c,v
retrieving revision 1.44
diff -u -p -a -u -p -r1.44 perl.c
--- gnu/usr.bin/perl/perl.c	15 Feb 2023 01:38:21 -0000	1.44
+++ gnu/usr.bin/perl/perl.c	21 May 2023 00:39:36 -0000
@@ -3,7 +3,7 @@
  *
  *    Copyright (C) 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
  *    2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012
- *    2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021, 2022
+ *    2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021, 2022, 2023
  *    by Larry Wall and others
  *
  *    You may distribute under the terms of either the GNU General Public
@@ -3832,7 +3832,7 @@ S_minus_v(pTHX)
 #endif
 
         PerlIO_printf(PIO_stdout,
-		      "\n\nCopyright 1987-2022, Larry Wall\n");
+		      "\n\nCopyright 1987-2023, Larry Wall\n");
 #ifdef OS2
         PerlIO_printf(PIO_stdout,
                       "\n\nOS/2 port Copyright (c) 1990, 1991, Raymond Chen, Kai Uwe Rommel\n"
Index: gnu/usr.bin/perl/pp_ctl.c
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/pp_ctl.c,v
retrieving revision 1.24
diff -u -p -a -u -p -r1.24 pp_ctl.c
--- gnu/usr.bin/perl/pp_ctl.c	15 Feb 2023 01:36:13 -0000	1.24
+++ gnu/usr.bin/perl/pp_ctl.c	21 May 2023 00:39:36 -0000
@@ -653,15 +653,15 @@ PP(pp_formline)
                             break;
                     }
                     else {
+                        if (size == fieldsize)
+                            break;
                         if (strchr(PL_chopset, *s)) {
                             /* provisional split point */
                             /* for a non-space split char, we include
                              * the split char; hence the '+1' */
                             chophere = s + 1;
-                            itemsize = size;
+                            itemsize = size + 1;
                         }
-                        if (size == fieldsize)
-                            break;
                         if (!isCNTRL(*s))
                             gotsome = TRUE;
                     }
@@ -3347,11 +3347,16 @@ S_docatch(pTHX_ Perl_ppaddr_t firstpp)
     case 0:
         PL_op = firstpp(aTHX);
  redo_body:
-        CALLRUNOPS(aTHX);
+        if (PL_op) {
+            CALLRUNOPS(aTHX);
+        }
         break;
     case 3:
-        /* die caught by an inner eval - continue inner loop */
-        if (PL_restartop && PL_restartjmpenv == PL_top_env) {
+        if (PL_restartjmpenv == PL_top_env) {
+            /* die caught by an inner eval - continue inner loop */
+
+            if (!PL_restartop)
+                break;
             PL_restartjmpenv = NULL;
             PL_op = PL_restartop;
             PL_restartop = 0;
Index: gnu/usr.bin/perl/pp_hot.c
===================================================================
RCS file: /usr/obj/OP/cvs/src/gnu/usr.bin/perl/pp_hot.c,v
retrieving revision 1.24
diff -u -p -a -u -p -r1.24 pp_hot.c
--- gnu/usr.bin/perl/pp_hot.c	15 Feb 2023 01:36:13 -0000	1.24
+++ gnu/usr.bin/perl/pp_hot.c	21 May 2023 00:39:36 -0000
@@ -861,7 +861,7 @@ PP(pp_multiconcat)
         /* Note that we iterate the loop nargs+1 times: to append nargs
          * arguments and nargs+1 constant strings. For example, "-$a-$b-"
          */
-        svpv_p = svpv_base - 1;
+        svpv_p = svpv_base;
 
         for (;;) {
             SSize_t len = (const_lens++)->ssize;
@@ -873,7 +873,7 @@ PP(pp_multiconcat)
                 const_pv += len;
             }
 
-            if (++svpv_p == svpv_end)
+            if (svpv_p == svpv_end)
                 break;
 
             /* append next arg */
@@ -901,6 +901,7 @@ PP(pp_multiconcat)
                     targ_pv += len;
             }
 
+            ++svpv_p;
         }
     }
 
